/**
 *  Copyright (c) 2021, Texas Instruments Incorporated
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  *   Redistributions of source code must retain the above copyright
 *  notice, this list of conditions and the following disclaimer.
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  *   Neither the name of Texas Instruments Incorporated nor the names of
 *  its contributors may be used to endorse or promote products derived
 *  from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 *  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 *  PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 *  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 *  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 *  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 *  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 *  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 *  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

import { Prop, Component, Element } from '@stencil/core';
import { Usb2anyUartCodec } from '../gc-codec-usb2any-uart/lib/Usb2anyUartCodec';
import { GcCodecBaseProps } from '../gc-target-configuration/gc-codec-base-props';
import { GcCodecUartBaseProps } from '../gc-target-configuration/gc-codec-uart-base-props';
import { createTargetParamsProxy } from '../gc-target-device-programmable/TargetDeviceParamsProxy';

/**
 * `gc-codec-usb2any-uart` is a non visual component for encoding and decoding UART messages for USB2ANY.
 *
 * @usage
 * @label USB2ANY Uart Codec
 * @group Transports, Models, and Codecs
 */
@Component({
    tag: 'gc-codec-usb2any-uart',
    shadow: true
})

export class GcCodecUsb2anyUart implements GcCodecUartBaseProps, GcCodecBaseProps {
    private impl: Usb2anyUartCodec | undefined;

    connectedCallback() {
        this.impl = new Usb2anyUartCodec(createTargetParamsProxy(this.el));
    }

    disconnectedCallback() {
        this.impl.dispose();
    }

    /**
     * Parity.
     *
     * @order 50
     */
    @Prop() parity: 'none' | 'even' | 'odd' = 'none';

    /**
     * Defines which bit of each byte is sent first.
     *
     * @order 51
     */
    @Prop() bitDirection: 'lsb' | 'msb' = 'lsb';


    /**
     * Number of data bits in each character.
     *
     * @order 52
     */
    @Prop() characterLength: 7 | 8 = 8;

    // #region gc-target-configuration/gc-codec-uart-base-props.tsx:
    // -----------Autogenerated - do not edit--------------
    /**
     * Baud rate.
     *
     * @order 61
     */
    @Prop() baudRate = 9600;

    /**
     * Number of stop bits.
     *
     * @order 62
     */
    @Prop() stopBits: 1 | 2 = 1;

    // #endregion
    // #region gc-target-configuration/gc-codec-base-props.tsx:
    // -----------Autogenerated - do not edit--------------
    /**
     * A flag indicating that this model, transport, codec, or device is not necessary for connecting
     * to the target.  Any failure should not prevent the connection from continuing, which may
     * result in a partial connection.
     *
     * @order 77
     */
    @Prop() optional: boolean = false;

    /**
     * An optional identifier of a target device that is associated with this model, transport or codec.
     * Specifying a target device indicates that this component is necessary and/or optional for
     * properly connecting to the target device.  If a required component fails to connect, other components
     * will not be connected that are associated with the same device by id.  This way you can associate
     * a gc-target-program-loader with a gc-transport-usb so that if the program fails to load the transport
     * will not attempt to connect and will fail, unless the gc-target-program-loader has the optional property
     * set.  The absence of a target device indicates this is necessary and/or optional
     * for connecting to any device.  As a result, specifying the deviceId is not necessary if you only have
     * one device in you target configuration, any failure to connect will result in the entire connection
     * being aborted.
     *
     * @order 80
     */
    @Prop() deviceId: string;

    @Element() el: HTMLElement;
    // #endregion

}
